<?php
/**
 * @package	Hikashop ReCaptcha V2 Plugin
 * @version	4.4.7
 * @author	HikaShop
 * @copyright	(C) 2010-2023 HIKARI SOFTWARE. All rights reserved.
 * @license	GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
$pluginCompat = JPATH_ROOT.'/administrator/components/com_hikashop/pluginCompat.php';
if(file_exists($pluginCompat)) {
	include_once($pluginCompat);
	class plgSystemRecaptcha2Bridge extends hikashopJoomlaPlugin{}
} else {
	class plgSystemRecaptcha2Bridge extends JPlugin{}
}
#[\AllowDynamicProperties]
class plgSystemRecaptcha2 extends plgSystemRecaptcha2Bridge
{
	public $components = array('com_user','com_users','com_alpharegistration','com_ccusers','com_virtuemart','com_hikashop','com_hikamarket','com_akeebasubs');
	public $captchaAdded = null;

	function __construct(&$subject, $config) {
		parent::__construct($subject, $config);
		$this->_init();
	}

	function _init() {
		if(isset($this->params))
			return;

		$plugin = JPluginHelper::getPlugin('system', 'recaptcha2');
		if(version_compare(JVERSION,'2.5','<')) {
			jimport('joomla.html.parameter');
			$this->params = new JParameter($plugin->params);
		} else {
			$this->params = new JRegistry($plugin->params);
		}
	}

	function onHikashopBeforeDisplayView(&$view) {
		$viewName = $view->getName();
		if($viewName == 'checkout')
			$this->_handleNewCheckout($view);
		if($viewName == 'user' && $view->getLayout() == 'form')
			$this->_handleNewRegForm($view);
	}
	function onHikamarketBeforeDisplayView(&$view) {
		$viewName = $view->getName();
		if($viewName == 'vendormarket' && $view->getLayout() == 'form')
			$this->_handleHikaMarketRegForm($view);
	}
	function _handleHikaMarketRegForm(&$view) {
		$config = hikashop_config();
		$this->captchaAdded = true;

		$user = JFactory::getUser();
		if(!$user->guest)
			return;

		if(!isset($view->extraData))
			$view->extraData = new stdClass();

		switch($this->params->get('fieldafter','password')) {
			case 'email':
				$after = 'top';
				break;
			case 'end':
				$after = 'bottom';
				break;
			default:
				$after = 'middle';
				break;
		}
		$subText = $this->params->get('captchatext');
		if(empty($subText)){
			$subText = JText::_('Captcha');
		}

		$invisible = $this->params->get('invisible', '');

		$c = new hikaShopRecaptcha2();
		$html = $c->recaptcha_get_html($this->params->get('public_key'),$this->params->get('theme'), @$view->ajax, $invisible);
		if(empty($invisible) || $invisible == 'inline')
			$html = '<dt class="hikamarket_' . $view->form_type . '_captcha_line"><label id="captchamsg" class="captchamsg" title="">'.$subText.'*</label></dt><dd class="hikamarket_' . $view->form_type . '_captcha_line">'.$html.'</dd>';
		if(!isset($view->extraData->$after))
			$view->extraData->$after = array();
		$view->extraData->{$after}[] = $html;
	}

	function _handleNewRegForm(&$view) {
		$config = hikashop_config();
		$this->captchaAdded = true;

		if(!isset($view->extraData))
			$view->extraData = new stdClass();

		switch($this->params->get('fieldafter','password')) {
			case 'email':
				$after = 'top';
				break;
			case 'end':
				$after = 'bottom';
				break;
			default:
				$after = 'middle';
				break;
		}
		$subText = $this->params->get('captchatext');
		if(empty($subText)){
			$subText = JText::_('Captcha');
		}

		$invisible = $this->params->get('invisible', '');

		$c = new hikaShopRecaptcha2();
		$html = $c->recaptcha_get_html($this->params->get('public_key'),$this->params->get('theme'), @$view->ajax, $invisible);
		if(empty($invisible) || $invisible == 'inline')
			$html = '<div class="hkform-group control-group hikashop_registration_recaptcha_line" id="hikashop_registration_recaptcha_line"><label id="captchamsg" class="hkc-sm-4 hkcontrol-label" title="">'.$subText.'*</label><div class="hkc-sm-8">'.$html.'</div></div>';
		if(!isset($view->extraData->$after))
			$view->extraData->$after = array();
		$view->extraData->{$after}[] = $html;
	}
	function _handleNewCheckout(&$view) {
		$config = hikashop_config();
		if($config->get('checkout_legacy',0))
			return true;

		if(!isset($view->workflow_step) || !isset($view->workflow) || !isset($view->workflow['steps'][$view->workflow_step]['content']))
			return true;

		if(!$this->params->get('registration',1))
			return true;

		if(!isset($view->extraData))
			$view->extraData = array();

		switch($this->params->get('fieldafter','password')) {
			case 'email':
				$after = 'top';
				break;
			case 'end':
				$after = 'bottom';
				break;
			default:
				$after = 'middle';
				break;
		}
		$subText = $this->params->get('captchatext');
		if(empty($subText)){
			$subText = JText::_('Captcha');
		}

		$invisible = $this->params->get('invisible', '');

		$c = new hikaShopRecaptcha2();
		$html = $c->recaptcha_get_html($this->params->get('public_key'),$this->params->get('theme'), @$view->ajax, $invisible);
		if(empty($invisible) || $invisible == 'inline')
			$html = '<div class="hkform-group control-group hikashop_registration_recaptcha_line" id="hikashop_registration_recaptcha_line"><label id="captchamsg" class="hkc-sm-4 hkcontrol-label" title="">'.$subText.'*</label><div class="hkc-sm-8">'.$html.'</div></div>';
		foreach($view->workflow['steps'][$view->workflow_step]['content'] as $k => $v) {
			if($v['task'] != 'login')
				continue;
			if(!isset($view->extraData[$k]))
				$view->extraData[$k] = new stdClass();
			if(!isset($view->extraData[$k]->$after))
				$view->extraData[$k]->$after = array();

			$view->extraData[$k]->{$after}[] = $html;
		}
	}

	function onAfterRender() {
		$app = JFactory::getApplication();
		if(version_compare(JVERSION,'3.0','<')) {
			$option = JRequest::getCmd('option');
		} else {
			$option = $app->input->getCmd('option');
		}

		if(empty($option)) return;

		$user = JFactory::getUser();
		if (!$user->guest) {
			return true;
		}

		$components = array();
		$components['com_user'] = array('view' => array('register'),'lengthafter' => 200);
		$components['com_users'] = array('view' => array('registration'),'lengthafter' => 200, 'email' => 'jform\[email2\]', 'password' => 'jform\[password2\]');
		$components['com_alpharegistration'] = array('view' => array('register'),'lengthafter' => 250);
		$components['com_ccusers'] = array('view' => array('register'),'lengthafter' => 500);
		$components['com_virtuemart'] = array('view' => array('shop.registration'),'viewvar' => 'page','lengthafter' => 500);
		$components['com_hikashop'] = array('view' => array('checkout','user'),'viewvar' => 'ctrl', 'lengthafter' => 500 , 'tdclass' => 'key', 'email' => 'data\[register\]\[email_confirm\]','password' => 'data\[register\]\[password2\]');
		$components['com_hikamarket'] = array('view' => array('vendor'),'viewvar' => 'ctrl', 'lengthafter' => 500 , 'tdclass' => 'key', 'email' => 'data\[register\]\[email_confirm\]', 'password' => 'data\[register\]\[password2\]');
		$components['com_akeebasubs'] = array('view' => array('level'),'lengthafter' => 200, 'email' => 'email2', 'password' => 'password2');
		if($this->params->get('contact',0)){
			$components['com_hikashop']['view'][]='product';
			$components['com_hikashop']['contact']=1;
			$components['com_contact'] = array('view' => array('contact'),'lengthafter' => 200,'contact'=>1);
			if(version_compare(JVERSION,'1.6','>=')){
				$components['com_contact']['contact_text'] = 'jform_contact_message';
				$components['com_contact']['contact_email'] = 'jform_contact_email';
				$components['com_contact']['contact_email_copy'] = 'jform_contact_email_copy';
			}
			$components['com_gcontact'] = array('view' => array('registration'),'lengthafter' => 200,'contact'=>1);
			$components['com_qcontacts'] = array('view' => array('contact'),'lengthafter' => 400,'contact'=>1);
			$components['com_contact_enhanced'] = array('view' => array('contact'),'lengthafter' => 200,'contact'=>1, 'contact_text' => 'cf_4', 'contact_email' => 'email');
		}

		if($this->params->get('comment',0)){
			$components['com_hikashop']['view'][] = 'product';
			$components['com_hikashop']['comment']=1;
		}

		if(!isset($components[$option])) return;
		$viewVar = (isset($components[$option]['viewvar']) ? $components[$option]['viewvar'] : 'view');


		if(version_compare(JVERSION,'3.0','<')) {
			$task = JRequest::getCmd($viewVar, JRequest::getCmd('task'));
		} else {
			$task = $app->input->getCmd($viewVar, $app->input->getCmd('task'));
		}

		if(!in_array($task,$components[$option]['view'])) return;

		if(!defined('DS'))
			define('DS', DIRECTORY_SEPARATOR);
		if(!include_once(rtrim(JPATH_ADMINISTRATOR,DS).DS.'components'.DS.'com_hikashop'.DS.'helpers'.DS.'helper.php')) return true;

		$config = hikashop_config();
		if(!$config->get('checkout_legacy',0) && version_compare($config->get('version'),'3.0.0') >= 0 && $task == 'checkout' || !empty($this->captchaAdded)){
			return true;
		}

		$subText = $this->params->get('captchatext');
		if(empty($subText)){
			$subText = JText::_('Captcha').':';
		}
		$invisible = $this->params->get('invisible', '');
		if(class_exists('JResponse'))
			$body = JResponse::getBody();
		$alternate_body = false;
		if(empty($body)){
			$app = JFactory::getApplication();
			$body = $app->getBody();
			$alternate_body = true;
		}

		if(!empty($components[$option]['comment'])){
			$id = $this->params->get('commentpos','hikashop_vote_comment');
			if($option=='com_hikashop'){
				switch($id){
					case 'pseudo_comment':
						$after = 'id=\'pseudo_comment\' ?v?a?l?u?e?=?\'?0?\'?/>';
						break;
					case 'email_comment':
						$after = 'id=\'email_comment\' value=\'0?\'/>';
						break;
					case 'hikashop_vote_comment':
					default:
						$after = 'id="hikashop_vote_comment".{0,'.$components[$option]['lengthafter'].'}</textarea>';
						break;
				}
				$c = new hikaShopRecaptcha2();
				$c->params = $this->params;
				$return = $c->recaptcha_get_html($this->params->get('public_key'),$this->params->get('theme'), false, $invisible);
				if(empty($invisible) || $invisible == 'inline')
					$return = '<table class="hikashop_comment_form"><tr class="hikashop_captcha"><td valign="top">'.$subText.'</td><td>'.$return.'</td></tr></table>';
				$replace= $after;
			}
			if(preg_match('#'.$replace.'#Uis',$body)){
				$body = preg_replace('#('.$replace.')#Uis','$1'.$return,$body,1);
				if($alternate_body){
					$app->setBody($body);
				}else{
					JResponse::setBody($body);
				}
				return;
			}
			if($option!='com_hikashop'){
				return true;
			}
		}

		if(!empty($components[$option]['contact'])){
			$id = $this->params->get('checkpos','contact_text');
			if($option=='com_hikashop'){
				switch($id){
					case 'contact_email_copy':
					case 'contact_email':
						$after = 'data\[contact\]\[email\]';
						break;
					case 'contact_text':
					default:
						$after = 'data\[contact\]\[altbody\]';
						break;
				}
				$c = new hikaShopRecaptcha2();
				$c->params = $this->params;
				$return = $c->recaptcha_get_html($this->params->get('public_key'),$this->params->get('theme'), false, $invisible);
				if(empty($invisible) || $invisible == 'inline')
					$return = '<dt>'.$subText.'</dt><dd class="hikashop_captcha">'.$return.'</dd>';
				$replace= 'name="'.$after.'".{0,'.$components[$option]['lengthafter'].'}</dd>';
				if(preg_match('#'.$replace.'#Uis',$body)){
					$body = preg_replace('#('.$replace.')#Uis','$1'.$return,$body,1);
					if($alternate_body){
						$app->setBody($body);
					}else{
						JResponse::setBody($body);
					}
					return;
				}
				$return = $c->recaptcha_get_html($this->params->get('public_key'),$this->params->get('theme'), false, $invisible);
				if(empty($invisible) || $invisible == 'inline')
					$return = '<tr class="hikashop_captcha"><td valign="top">'.$subText.'</td><td>'.$return.'</td></tr>';
				$replace= 'name="'.$after.'".{0,'.$components[$option]['lengthafter'].'}</tr>';
			}else{
				$c = new hikaShopRecaptcha2();
				$c->params = $this->params;
				if(isset($components[$option][$id])) $id = $components[$option][$id];
				$replace = 'id="'.$id.'".{0,'.$components[$option]['lengthafter'].'}(<br */>|</p>|</div>|</dd>)';
				$return = $c->recaptcha_get_html($this->params->get('public_key'),$this->params->get('theme'), false, $invisible);
				if($option=='com_contact' && version_compare(JVERSION,'3.0','>=')){
					if(empty($invisible) || $invisible == 'inline') {
						$return = '
<div class="control-group">
	<div class="control-label">
		<label id="recaptcha_response_field-lbl" for="recaptcha_response_field" class="required">
			'.$subText.'
			<span class="star">&nbsp;*</span>
		</label>
	</div>
	<div class="controls">'.$return.'</div>
</div>';
					}
					$replace = 'id="'.$id.'".{0,'.$components[$option]['lengthafter'].'}(<\/div>\r?\n?\t*<\/div>)';
				}elseif($option=='com_contact' && version_compare(JVERSION,'1.6','>=')){
					if(empty($invisible) || $invisible == 'inline') {
						$return = '<dt>'.$subText.'</dt><dd class="hikashop_captcha">'.$return.'</dd>';
					}
				}else{
					if(empty($invisible) || $invisible == 'inline') {
						$return = '<label>'.$subText.'</label><br/><span class="hikashop_captcha">'.$return.'</span><br />';
					}
				}

			}

			if(preg_match('#'.$replace.'#Uis',$body)){
				$body = preg_replace('#('.$replace.')#Uis','$1'.$return,$body,1);
				if($alternate_body){
					$app->setBody($body);
				}else{
					JResponse::setBody($body);
				}
				return;
			}
			if($option!='com_hikashop'){
				return true;
			}
		}

		if($this->params->get('registration',1)){
			$afterKey = $this->params->get('fieldafter','password');
			if(!empty($components[$option][$afterKey])){
				$after = $components[$option][$afterKey];
			}elseif($afterKey == 'end'){
				$fieldsClass = hikashop_get('class.field');
				$null = null;
				$fields = $fieldsClass->getFields('frontcomp', $null, 'address');
				if(count($fields)){
					end($fields);
					$after =  'data\[address\]\['.key($fields).'\]';
				}
			}elseif($afterKey == 'custom'){
				$after =  $this->params->get('fieldaftercustom');
			}else{
				$after = ($afterKey == 'email') ? $components[$option]['email'] : $components[$option]['password'];
			}
			$c = new hikaShopRecaptcha2();
			$return = $c->recaptcha_get_html($this->params->get('public_key'),$this->params->get('theme'), false, $invisible);

			if(!$this->parseBody($body,$after,$components[$option]['lengthafter'],$return,$subText,$invisible)){
				if($option=='com_hikashop' || $option=='com_hikamarket'){
					if($after=='data\[register\]\[password2\]'){
						$after='data\[register\]\[email_confirm\]';
						if($this->parseBody($body,$after,$components[$option]['lengthafter'],$return,$subText,$invisible)){
							return true;
						}
					}
					if($after=='data\[register\]\[email_confirm\]'){
						$after='data\[register\]\[email\]';
						$this->parseBody($body,$after,$components[$option]['lengthafter'],$return,$subText,$invisible);
					}
				}
			}
		}
	}

	function parseBody(&$body,$after,$lengthafter,$return,$subText,$invisible=false){
		if(class_exists('JResponse'))
			$backwardCompat = JResponse::getBody();
		$alternate_body = false;
		if(empty($backwardCompat)){
			$alternate_body = true;
		}
		$app = JFactory::getApplication();
		if(preg_match('#(name="'.$after.'".{0,'.$lengthafter.'}</tr>)#Uis',$body)){
			if(empty($invisible) || $invisible == 'inline')
				$return = '<tr class="recaptcha"><td valign="top">'.$subText.'</td><td>'.$return.'</td></tr>';
			$body = preg_replace('#(name="'.$after.'".{0,'.$lengthafter.'}</tr>)#Uis','$1'.$return,$body,1);
			if($alternate_body){
				$app->setBody($body);
			}else{
				JResponse::setBody($body);
			}
			return true;
		}

		if(preg_match('#(name="'.$after.'".{0,'.$lengthafter.'}</div>)#Uis',$body)){
			if(empty($invisible) || $invisible == 'inline') {
				if(preg_match('#id="(akeebasubs|member-registration)"#Uis', $body)){
					$return = '</div><div class="control-group"><label class="control-label required" for="recaptcha_response_field">'.$subText.'<span class="star">&nbsp;*</span></label><div class="recaptcha controls">'.$return.'</div>';
				}else{
					$return = '<div class="recaptcha"><label>'.$subText.'</label>'.$return.'</div>';
				}
			}
			$body = preg_replace('#(name="'.$after.'".{0,'.$lengthafter.'}</div>)#Uis','$1'.$return,$body,1);
			if($alternate_body){
				$app->setBody($body);
			}else{
				JResponse::setBody($body);
			}
			return true;
		}
		if(preg_match('#(name="'.$after.'".{0,'.$lengthafter.'}</p>)#Uis',$body)){
			if(empty($invisible) || $invisible == 'inline')
				$return = '<div class="recaptcha"><label>'.$subText.'</label>'.$return.'</div>';
			$body = preg_replace('#(name="'.$after.'".{0,'.$lengthafter.'}</p>)#Uis','$1'.$return,$body,1);
			if($alternate_body){
				$app->setBody($body);
			}else{
				JResponse::setBody($body);
			}
			return true;
		}
		if(preg_match('#(name="'.$after.'".{0,'.$lengthafter.'}</dd>)#Uis',$body)){
			if(empty($invisible) || $invisible == 'inline')
				$return = '<dt class="recaptcha"><label>'.$subText.'</label></dt><dd>'.$return.'</dd>';
			$body = preg_replace('#(name="'.$after.'".{0,'.$lengthafter.'}</dd>)#Uis','$1'.$return,$body,1);
			if($alternate_body){
				$app->setBody($body);
			}else{
				JResponse::setBody($body);
			}
			return true;
		}
		return false;
	}

	function onUserBeforeSave($user, $isnew, $new){
		return $this->onBeforeStoreUser($user, $isnew);
	}

	function onSubmitContact($contact,$post){
		$app = JFactory::getApplication();

		if(version_compare(JVERSION,'4.0','>=') && $app->isClient('administrator'))
			return true;
		if(version_compare(JVERSION,'4.0','<') && $app->isAdmin())
			return true;

		$this->_init();
		if(!$this->params->get('contact',0)){
			return true;
		}
		return $this->_checkCaptcha();
	}

	function onBeforeVoteCreate(&$element,&$do,&$error){
		$app = JFactory::getApplication();
		if(version_compare(JVERSION,'4.0','>=') && $app->isClient('administrator'))
			return true;
		if(version_compare(JVERSION,'4.0','<') && $app->isAdmin())
			return true;
		$this->_init();
		if(!$this->params->get('comment',0)){
			return true;
		}
		if(!isset($element->vote_comment) || empty($element->vote_comment)){
			return true;
		}

		$token = '';
		if(isset($element->recaptchaResponse)){
			$token = $element->recaptchaResponse;
			unset($element->recaptchaResponse);
		}

		$do = $this->_checkCaptcha(false, $token);


		$error[] = $this->errorCodes;
		return true;
	}

	function onBeforeSendContactRequest(&$element,&$send){
		$app = JFactory::getApplication();

		if(version_compare(JVERSION,'4.0','>=') && $app->isClient('administrator'))
			return true;
		if(version_compare(JVERSION,'4.0','<') && $app->isAdmin())
			return true;
		$this->_init();
		if(!$this->params->get('contact',0)){
			return true;
		}
		$send = $this->_checkCaptcha(false);
		if(!empty($this->errorCodes))
			$app->enqueueMessage($this->errorCodes, 'error');
		return true;
	}

	function onBeforeStoreUser($user, $isnew, $new=null){
		if(!$isnew) return true;

		$app = JFactory::getApplication();
		if(version_compare(JVERSION,'4.0','>=')) {
			if($app->isClient('administrator'))
				return true;
		} else {
			if($app->isAdmin())
				return true;
		}

		$option = JFactory::getApplication()->input->get('option');
		$ctrl = JFactory::getApplication()->input->get('ctrl');
		$task = JFactory::getApplication()->input->get('task');


		if ($option=='com_updateme' && $ctrl=='subscription' && $task=='api') return true;

		if ($option=='com_hikashop' && $ctrl=='user' && $task=='guest_register') return true;


		if (!in_array($option,$this->components)) return true;

		$this->_init();
		if(!$this->params->get('registration',1)){
			return true;
		}

		return $this->_checkCaptcha();
	}

	function onBeforeHikaUserRegistration(&$ret, $input_data, $mode){

		$app = JFactory::getApplication();
		if(version_compare(JVERSION,'4.0','>=')) {
			if($app->isClient('administrator'))
				return true;
		} else {
			if($app->isAdmin())
				return true;
		}

		$option = JFactory::getApplication()->input->get('option');
		$ctrl = JFactory::getApplication()->input->get('ctrl');
		$task = JFactory::getApplication()->input->get('task');

		if ($option=='com_updateme' && $ctrl=='subscription' && $task=='api') return true;

		if ($option=='com_hikashop' && $ctrl=='user' && $task=='guest_register') return true;


		if (!in_array($option,$this->components)) return true;

		$this->_init();
		if(!$this->params->get('registration',1)){
			return true;
		}

		$ret['status'] = $this->_checkCaptcha(false);
		if(!$ret['status'])
			$ret['messages']['recaptcha'] = array($this->errorCodes, 'error');
	}

	function _checkCaptcha($redirect = true, $response = ''){
		static $done = false;
		if($done) return true;

		$user = JFactory::getUser();
		if (!$user->guest) {
			return true;
		}

		$c = new hikaShopRecaptcha2();

		if(empty($response))
			$response = @$_POST["g-recaptcha-response"];

		$resp = $c->recaptcha_check_answer($this->params->get('private_key'), @$_SERVER["REMOTE_ADDR"], $response);

		if(!empty($resp->success)){
			$done = true;
			return true;
		}

		$lang = JFactory::getLanguage();
		$lang->load('plg_system_recaptcha2', JPATH_ADMINISTRATOR);
		if(!empty($resp->errorCodes)){
			if(!is_array($resp->errorCodes)){
				$resp->errorCodes = array($resp->errorCodes);
			}
			foreach($resp->errorCodes as $k => $code){
				switch($code){
					default:
						$resp->errorCodes[$k] = JText::sprintf('CAPTCHA_ERROR_UNKNOWN', $code);
						break;
					case 'invalid-site-public-key':
						$resp->errorCodes[$k] = JText::_('CAPTCHA_ERROR_INVALIDPUBLICKEY');
						break;
					case 'missing-input-secret':
					case 'invalid-input-secret':
						$resp->errorCodes[$k] = JText::_('CAPTCHA_ERROR_INVALIDPRIVATEKEY');
						break;
					case 'invalid-request-cookie':
						$resp->errorCodes[$k] = JText::_('CAPTCHA_ERROR_INVALIDREQUESTCOOKIE');
						break;
					case 'missing-input':
					case 'missing-input-response':
					case 'invalid-input-response':
						$resp->errorCodes[$k] = JText::_('CAPTCHA_ERROR_INCORRECTSOLUTION');
						break;
					case 'verify-params-incorrect':
						$resp->errorCodes[$k] = JText::_('CAPTCHA_ERROR_INCORRECTPARAMETERS');
						break;
					case 'invalid-referrer':
						$resp->errorCodes[$k] = JText::_('CAPTCHA_ERROR_INVALIDREFERRER');
						break;
					case 'recaptcha-not-reachable':
						$resp->errorCodes[$k] = JText::_('CAPTCHA_ERROR_UNREACHABLERECAPTCHA');
						break;
				}
			}
		}else{
			$resp->errorCodes = JText::_('CAPTCHA_ERROR_UNREACHABLERECAPTCHA');
		}

		if(is_array($resp->errorCodes)){
			$resp->errorCodes = implode('<br/>',$resp->errorCodes);
		}

		if($redirect){
			$app = JFactory::getApplication();
			$app->enqueueMessage($resp->errorCodes,'error');
			$app->redirect(@$_SERVER['HTTP_REFERER']);
		}else{
			$this->errorCodes = $resp->errorCodes;
		}
		return false;
	}

}//endclass

#[\AllowDynamicProperties]
class hikaShopRecaptcha2 {

	function recaptcha_get_html($pubkey, $theme, $ajax = false, $invisible = false) {
		if($pubkey == null || $pubkey == '') {
			die ("To use reCAPTCHA you must get an API key from <a href='https://www.google.com/recaptcha/admin'>https://www.google.com/recaptcha/admin</a>");
		}

		$params = array('\'sitekey\':\''.$pubkey.'\'');
		$js = '';

		if(!empty($invisible)) {
			$params[] = '\'size\':\'invisible\'';
			$params[] = '\'badge\':\''.$invisible.'\'';
			$params[] = '\'callback\':\'hkCaptcha\'';
			$js = "
var captchaEl = document.querySelector('#hika-recaptcha textarea');
if(captchaEl) {
	if(window.checkout && window.Oby) {
		window.Oby.registerAjax('checkoutBlockSubmit', function(params) {
			var localEl = document.querySelector('#hika-recaptcha textarea');
			if(localEl.value || params.type != 'login') return;
			window.captchaParams = params;
			grecaptcha.execute(window.hkCaptchaWidget);
			return false;
		});
	}
	var submitBtns = captchaEl.form.querySelectorAll('button[type=\"submit\"]');
	if(submitBtns) {
		document.body.addEventListener('click', function(e) {
	        var targetElement = e.target || e.srcElement;
	        var foundBtn = false;
	        submitBtns.forEach(function(submitBtn) {
		        if(targetElement.isSameNode(submitBtn))
					foundBtn = true;
			});

			if(!foundBtn)
				return true;

			if(captchaEl.value)
				return true;

			if(e.stopPropagation)
				e.stopPropagation();
			e.stopImmediatePropagation();
			e.preventDefault();
			window.captchaFormSubmit = targetElement;
			grecaptcha.execute(window.hkCaptchaWidget);
	        return false;
		}, true);
	}

	window.hkCaptcha = function(token) {
		if(window.captchaParams) {
			var p = window.captchaParams;
			window.checkout.submitBlock(p.type, p.cid, p.pos, p.data);
			window.captchaParams = null;
		}
		if(window.captchaFormSubmit) {
			window.captchaFormSubmit.click();
		}
	}
}
";
		} else {
			$params[] = '\'theme\':\''.$theme.'\'';
		}

		$params = '{' . implode(', ', $params) . '}';
		$lang = JFactory::getLanguage();
		$tag = $lang->get('tag');
		$locale = strtolower(substr($lang->get('tag'),0,2));
		if(in_array($tag, array('zh-CN','zh-TW','en-GB','fr-CA','de-AT','de-CH','pt-BR','pt-PT'))){
			$locale = $tag;
		}elseif($tag == 'he-IL'){
			$locale = 'iw';
		}elseif($tag == 'nn-NO' || $tag == 'nb-NO'){
			$locale = 'no';
		}elseif(!in_array($locale,array('af','ar','bg','ca','hr','cs','da','et','nl','en','fil','hy','fi','fr','de','el','iw','hi','hu','id','it','ja','ka','ko','lv','lt','ms','no','fa','pl','pt','ro','ru','sr','sk','si','sl','es','sv','sw','ta','th','tr','uk','vi'))){
			$locale = 'en';
		}

		return '
<div id="hika-recaptcha" class="hika-recaptcha"></div>
<script type="text/javascript">
	var onloadCallbackHKRecaptcha = function() {
			window.hkCaptchaWidget = grecaptcha.render(\'hika-recaptcha\', '.$params.');
			'.$js.'
	};
	document.addEventListener("DOMContentLoaded", function(){
		var scriptTag = document.createElement(\'script\');
		scriptTag.src = "https://www.google.com/recaptcha/api.js?onload=onloadCallbackHKRecaptcha&render=explicit&hl='.$locale.'";
		scriptTag.defer = true;
		document.body.appendChild(scriptTag);
	});

	if(window.checkout && window.Oby) {
		window.Oby.registerAjax("checkoutBlockRefresh", function(params) {
			if(params.type != \'login\') return;
			onloadCallbackHKRecaptcha();
		});
	}
</script>';
	}

	function recaptcha_check_answer ($privkey, $remoteip, $response, $extra_params = array())
	{
		if ($privkey == null || $privkey == '') {
			die ("To use reCAPTCHA you must get an API key from <a href='https://www.google.com/recaptcha/admin'>https://www.google.com/recaptcha/admin</a>");
		}

		if ($remoteip == null || $remoteip == '') {
			die ("For security reasons, you must pass the remote ip to reCAPTCHA");
		}

		if ($response == null || strlen($response) == 0) {
			$recaptchaResponse = new HikaShopReCaptchaResponse2();
			$recaptchaResponse->success = false;
			$recaptchaResponse->errorCodes = 'missing-input';
			return $recaptchaResponse;
		}
		$getResponse = $this->_submitHTTPGet(
			"https://www.google.com/recaptcha/api/siteverify?",
			array (
				'secret' => $privkey,
				'remoteip' => $remoteip,
				'v' => "php_1.0",
				'response' => $response
			)
		);
		$answers = json_decode($getResponse, true);
		$recaptchaResponse = new HikaShopReCaptchaResponse2();
		if ($answers['success'] == true) {
			$recaptchaResponse->success = true;
		} else {
			$recaptchaResponse->success = false;
			$recaptchaResponse->errorCodes = $answers['error-codes'];
		}
		return $recaptchaResponse;

	}

	function _encodeQS($data)
	{
		$req = "";
		foreach ($data as $key => $value) {
			$req .= $key . '=' . urlencode(stripslashes($value)) . '&';
		}
		$req=substr($req, 0, strlen($req)-1);
		return $req;
	}

	function _submitHTTPGet($path, $data)
	{
		$req = $this->_encodeQS($data);
		$response = file_get_contents($path . $req);
		if( $response == false ) {
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, $path . $req);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			$response = curl_exec($ch);
			curl_close($ch);
		}
		return $response;
	}

}

class HikaShopReCaptchaResponse2 {
	var $success;
	var $errorCodes;
}
